// Code to get String input from the user while the program is running
// Seems to work in an applet
// Stops at the return key input
//  Copyright
//  Jim Roberts
//  Pittsburgh, PA 15221
//  November 2012

PFont f1;
String inputString = "";
boolean gettingInput;

void setup(  )
{
  size( 400, 400 );

  f1 = loadFont( "f1.vlw");
  
  gettingInput = true;
}

void draw( )
{
  // We either get the user's input or evaluate the input
  if (gettingInput == true)
  {
     getUserInput( );
  }
  else
  { 
    evaluateInput( );
  }
}

void keyPressed( )
{
  // see if use is starting or stopping text input
  if( keyCode == RETURN || keyCode == ENTER)
  {
     // erase the contents of input from previous input
     if (gettingInput == false)
     {
         inputString = ""; 
     }
     // "toggles" boolean variable to the other value
     //  true becomes false OR false becomes true
     gettingInput = !gettingInput ;
  }
  // user is continuing text input
  else
  {
     // trying to cover both Windows and Mac... sigh...
     if (  keyCode == DELETE || keyCode == BACKSPACE )
     {   //protect the string bounds -- do not want to go negative
         if (inputString.length() > 0)
         { // remove the last entered character
           inputString = inputString.substring( 0, inputString.length()-1);
         }
     }
     // insure they pressed a character key
     else if (key != CODED)
     {
       inputString += key;
     }
   }
}


void  evaluateInput( )
{
    fill( 255 );
    rect( 10, 10, 380, 380);
    fill( 0 );
    textFont( f1 );
    text( inputString, 20, 50 );
   
    if ( inputString.length( ) > 0 )
    {
       if (inputString.equals( "Ohio" ) )
       {
        text("Great - that is correct", 20, 100); 
       }
       else
       {
        text("Sorry, you are wrong", 20, 100); 
       }
    }
    textFont( f1, 18 );
    text("Press the [RETURN ] key\n or the [ENTER] key to stop.", 20, 150);  
}

void getUserInput( )
{
    fill( 255, 0, 0 );
    rect( 10, 10, 380, 380);
    fill( 0 );
    textFont( f1 );
    text("What continent has the lowest \nhuman population?:\n" + inputString, 20, 50 );
    

    textFont( f1, 18 );
    text("Press the [ENTER] key\nor the [RETURN] key when you are done.", 20, 350);
  
}
